#ifndef DOMMODEL_H
#define DOMMODEL_H

#include <QAbstractItemModel>
#include <QtXml>
#include <QStandardItemModel>
#include <QStandardItem>
#include <QtWidgets>

class DomModel : public QTreeView
{
    Q_OBJECT

private:
    QStandardItemModel* model;
    QStandardItem *p_item;
    QStandardItem *item;
    QList<QStandardItem*> rootList;
    QStringList f_directoryList;
    QMenu* customMenu;
    QModelIndex index;
    QFile* f_currentFile;

private:
    void traverseNode(const QDomNode& p_dNode, QStandardItem* p_item_ptr);
    void simpleTraverseNode(const QDomNode& p_dNode, QStandardItem* p_item_ptr);

public:

    DomModel(QWidget* = 0);

public slots:
    void load();
    void load(const QString& f_directory);
    void simpleLoad(const QString& f_directory);
    void close();
    QList<QStandardItem*>* get_root();
    void set_root();
    void set_root(QModelIndex);
    void context_menu(QPoint);
    void context_menu_reader(QAction*);
    void drop_single(QModelIndex);

signals:

    void sigSendFile(QFile*);
};

#endif // DOMMODEL_H
